﻿/* Debugger.as — 1.00
   Permet à une animation Flash de communiquer avec Debugger.swf.
*/
// Constantes
var d_freezableEvents:Array = ["onData", "onDragOut", "onDragOver", "onEnterFrame", "onKeyDown", "onKeyUp", "onKillFocus", "onLoad", "onMouseDown", "onMouseMove", "onMouseUp", "onPress", "onRelease", "onReleaseOutside", "onRollOut", "onRollOver", "onSetFocus", "onUnload"];
var d_version:String = "1.00";
var d_allowedCharacters = {a: true, z: true, e: true, r: true, t: true, y: true, u: true, i: true, o: true, p: true, q: true, s: true, d: true, f: true, g: true, h: true, j: true, k: true, l: true, m: true, w: true, x: true, c: true, v: true, b: true, n: true, A: true, Z: true, E: true, R: true, T: true, Y: true, U: true, I: true, O: true, P: true, Q: true, S: true, D: true, F: true, G: true, H: true, J: true, K: true, L: true, M: true, W: true, X: true, C: true, V: true, B: true, N: true};
var d_movieclipProperties:Array = ["_alpha", "_currentframe", "_framesloaded", "_height", "_rotation", "_totalframes", "_visible", "_width", "_x", "_xscale", "_y", "_yscale", "enabled", "filters", "hitArea", "menu", "opaqueBackground", "scale9Grid", "scrollRect", "tabChildren", "tabEnabled", "tabIndex", "trackAsMenu", "transform", "useHandCursor", "onData", "onEnterFrame", "onKeyDown", "onKeyUp", "onKillFocus", "onLoad", "onMouseDown", "onMouseMove", "onMouseUp", "onPress", "onRelease", "onReleaseOutside", "onRollOut", "onRollOver", "onSetFocus", "onUnload"];
//var d_movieclipProperties = ["_alpha", "_currentframe", "_droptarget", "_focusrect", "_framesloaded", "_height", "_highquality", "_lockroot", "_name", "_parent", "_quality", "_rotation", "_soundbuftime", "_target", "_totalframes", "_url", "_visible", "_width", "_x", "_xmouse", "_xscale", "_y", "_ymouse", "_yscale", "blendMode", "cacheAsBitmap", "enabled", "filters", "focusEnabled", "hitArea", "menu", "opaqueBackground", "forceSmoothing", "scale9Grid", "scrollRect", "tabChildren", "tabEnabled", "tabIndex", "trackAsMenu", "transform", "useHandCursor", "onData", "onDragOut", "onDragOver", "onEnterFrame", "onKeyDown", "onKeyUp", "onKillFocus", "onLoad", "onMouseDown", "onMouseMove", "onMouseUp", "onPress", "onRelease", "onReleaseOutside", "onRollOut", "onRollOver", "onSetFocus", "onUnload"];
d_useMovieclipProperties = false;
// Variables
var d_watchedVariables:Array = [];
var d_currentVariablesListId:Number = null;
var d_swfId:String = null;
var d_password:String = null;
var d_authorized:Boolean = true;
var d_useTrace:Boolean = false;
var d_timer:Number = null;
var d_lastTime:Number = null;
var d_elapsedFrames:Number = 0;
var d_sessionId:Number = Math.random();
var d_frozeEvents:Array = null;

// LocalConnexion In
var d_localConnexionIn:LocalConnection = new LocalConnection();

// // Fonctions
d_localConnexionIn.changeWatchedVariables = function(variablesToWatch:Array, currentVariablesListId:Number) {
	d_watchedVariables = variablesToWatch;
	d_currentVariablesListId = currentVariablesListId;
	if (d_timer == null) {
		d_timer = setInterval(d_refresh, 1000/12);
		_root.createEmptyMovieClip("d_fpsCounter", -254);
		d_lastTime = getTimer();
		d_fpsCounter.onEnterFrame = d_fpsCounterPeriodical;
	}
	if (!d_authorized) {
		d_localConnexionOut.send("ChamykyDebuggerOut", "askForPassword");
	}
}
d_localConnexionIn.validatePassword = function(submittedPassword) {
	if (d_password == submittedPassword) {
		d_authorized = true;
	} else {
		d_localConnexionOut.send("ChamykyDebuggerOut", "askForPassword", true);
	}
}
d_localConnexionIn.changeRefreshInterval = function(refreshInterval:Number) {
	clearInterval(d_timer);
	d_timer = setInterval(d_refresh, refreshInterval);
}
d_localConnexionIn.executeFunction = function(functionName, arg1, arg2, arg3, arg4, arg5, arg6, arg7) {
	if (d_authorized) {
		if (typeof(eval(functionName)) == "function") {
			var resultFromFunction = eval(functionName)(arg1, arg2, arg3, arg4, arg5, arg6, arg7);
			d_log2("> "+functionName+": "+resultFromFunction);
		} else {
			d_log2("> "+functionName+": "+eval(functionName));
		}
	}
}
d_localConnexionIn.setVariable = function(variableName, valueToSet) {
	if (d_authorized) {
		set(variableName, valueToSet);
	}
}
d_localConnexionIn.announce = function() {
	d_localConnexionOut.send("ChamykyDebuggerOut", "startDebugging", d_swfId, d_sessionId, d_version);
}
d_localConnexionIn.freeze = function(froze) {
	if (d_authorized) {
		if ((d_frozeEvents == null) == froze) {
			if (froze) {
				// Freeze
				d_pause();
				d_frozeEvents = new Array();
				d_recursivelyFreezeEvents(_root);
			} else {
				// Unfreeze
				for (var eventId in d_frozeEvents) {
					var eventObject = d_frozeEvents[eventId];
					eventObject.targetObject[eventObject.eventName] = eventObject.associatedFunction;
				}
				d_frozeEvents = null;
				d_unpause();
			}
		}
	}
}
d_recursivelyFreezeEvents = function(targetObject) {
	for (var e in d_freezableEvents) {
		var eventName = d_freezableEvents[e];
		if (targetObject[eventName] != undefined) {
			d_frozeEvents.push({targetObject:targetObject, eventName: eventName, associatedFunction: targetObject[eventName]});
			delete(targetObject[eventName]);
		}
	}
	for (var child in targetObject) {
		if (typeof(targetObject[child]) == "Object") {
			d_searchForEvents(targetObject[child]);
		}
	}
}
d_localConnexionIn.sendTree = function () {
	if (d_authorized) {
		var treeArray = d_fillTreeArray(_root);
		//trace(o_create(treeArray,2));
		d_localConnexionOut.send("ChamykyDebuggerOut", "saveTree", treeArray, d_sessionId);
	}
}
function d_fillTreeArray(objectToScan) {
	var arrayToFill = new Array();
	// Listage/construction
	for (var o in objectToScan) {
		if (o.substr(0,2) != "d_") {
			var o2 = objectToScan[o];
			if (typeof(o2) == "movieclip" || typeof(o2) == "object" || typeof(o2) == "array") {
				arrayToFill[o] = d_fillTreeArray(o2);
			} else if (typeof(o2) == "function") {
				arrayToFill[o] = "[type Function]";
			} else {
				arrayToFill[o] = o2+"";
			}
		}
	}
	// Propriétés supplémentaires movieclip
	if (d_useMovieclipProperties) {
		for (var p in d_movieclipProperties) {
			var p = d_movieclipProperties[p];
			var p2 = objectToScan[p];
			if (typeof(p2) == "movieclip" || typeof(p2) == "object" || typeof(p2) == "array") {
				//arrayToFill[p] = d_fillTreeArray(p2);
			} else if (typeof(p2) == "function") {
				arrayToFill[p] = "[type Function]";
			} else if (p2 != undefined) {
				//arrayToFill[p] = p2+"";
			}
		}
	}
	// Tri
	var sortedArray = new Array();
	while (true) {
		var toAddNext = null;
		for (var item in arrayToFill) {
			if (toAddNext == null || ((toAddNext+"") < (item+""))) {
				toAddNext = item.toString();
			}
		}
		if (toAddNext == null) {
			break;
		}
		sortedArray[toAddNext] = arrayToFill[toAddNext];
		delete(arrayToFill[toAddNext]);
	}
	return sortedArray;
}
function d_sortBasedOnName(a, b):Number {
	return Math.round(Math.random());
}

// LocalConnexion Out
var d_localConnexionOut:LocalConnection = new LocalConnection();
function d_log2(textToLog) {
	d_localConnexionOut.send("ChamykyDebuggerOut", "log", textToLog, d_sessionId);
}
function d_log(textToLog) {
	if (s_sessionId != null) {
		d_log2("! "+textToLog);
	} else if(d_useTrace) {
		trace(textToLog);
	}
}

// FPS
d_fpsCounterPeriodical = function () {
	d_elapsedFrames++;
	if (d_elapsedFrames == 12) {
		d_fps = Math.round(1000/(getTimer()-d_lastTime)*12);
		d_lastTime = getTimer();
		d_elapsedFrames = 0;
	}
}

// Envoi périodique
function d_refresh() {
	if (d_frozeEvents == null && d_authorized) {
		var values:Array = new Array();
		for (var v in d_watchedVariables) {
			var valueToSend = eval(d_watchedVariables[v]);
			if (typeof(valueToSend) == "movieclip") {
				values.push(targetPath(valueToSend));
			} else if (typeof(valueToSend) == "function") {
				values.push("[type Function]");
			} else {
				values.push(valueToSend+"");
			}
		}
		d_localConnexionOut.send("ChamykyDebuggerOut", "refreshValues", values, d_currentVariablesListId);
	}
}

// Activation du débuggage
function d_enable(swfId, password) {
	// Vérification de swfId
	if (!isNaN(swfId.substr(0, 1))) {
		trace("Error: the id you chose isn't valid");
		d_localConnexionOut.send("ChamykyDebuggerOut", "log", "/!\\ A Flash movie attempted to connect with an incorrect id /!\\", null);
		break;
	}
	for (var i = 0 ; i < swfId.length ; i++) {
		var character = swfId.substr(i, 1);
		if (!d_allowedCharacters[character] && isNaN(character)) {
			trace("Error: the id you chose isn't valid");
			d_localConnexionOut.send("ChamykyDebuggerOut", "log", "/!\\ A Flash movie attempted to connect with an incorrect id /!\\", null);
			break;
		}
	}
	// Activation du débuggage
	d_localConnexionIn.connect("ChamykyDebuggerIn");
	d_swfId = swfId;
	d_localConnexionOut.send("ChamykyDebuggerOut", "startDebugging", swfId, d_sessionId, d_version);
	if (password) {
		d_password = password;
		d_authorized = false;
	}
}